<?php

/**
 * cgmv_inf_cuenta_pagar_sp actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage cgmv_inf_cuenta_pagar_sp
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cgmv_inf_cuenta_pagar_spActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' Order by fecha_radicado, radicado';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];

            /*
             * Variables opcionales
             */
            //id_contratista
            if (isset($request['id_mae_ter'])) {
                $whereIdmaeter = " AND tab0.id_mae_ter = " . $request['id_mae_ter'];
            } else {
                $whereIdmaeter = ' ';
            }
            //id_contrato
            if (isset($request['id_cen_op'])) {
                $whereIdCenop = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereIdCenop = ' ';
            }
            //id_numero_pago
            if (isset($request['no_factura'])) {
                $whereIdNoFactura = " AND tab0.no_factura = " . $request['no_factura'];
            } else {
                $whereIdNoFactura = ' ';
            }
            //Recurso: 0-ANM 1-SGR
            if (isset($request['recurso'])) {
                if ($request['recurso'] == 1) {
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 1 ";
                } elseif ($request['recurso'] == 0 && $request['recurso'] != 'false') {
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 0 ";
                } else {
                    $whereTipoRecurso = " ";
                }
            } else {
                $whereTipoRecurso = "";
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             * Consulta de pagos por fecha y estado aprobado
             * Recurso: 0-PGN 1-SGR 2-RESURSO COMPARTIDO
             * Cambiar  "Fecha Inicio de Pago"-"Fecha Aprobación Financiera ...:    - 20180822
             * Se cambios registros para buscar codigo por datos_compania para el PCIConexion - 20220301::LAVILA
             */
            $consulta_sql = <<<EOD
select

case when tab0.tipo_recurso = 0 then dat.CODIGO_SIIF
     when tab0.tipo_recurso = 1 then dat.CODIGO_SPGR 
      else NULL end as PCIConexion,
case when tab0.tipo_recurso = 0 then '03'
     when tab0.tipo_recurso = 1 then '1' 
     else NULL end as TipoCuentaPorPagar,
'No RP' as ConsecutivoCompromiso,
rownum as Consecutivo,
tab0.*

from(

    select  
    forpag.tipo_recurso_sede as tipo_recurso,
    'RP_ANM' as rp_anm,
    'RP_SGR' as rp_sgr,
    0 as declarante_renta,
    null as num_cuenta,
    --tc.descripcion as tipo_cuenta,
    --'1 ó 03' as tipo_cuenta,
    to_char(sysdate,'yyyy-mm-dd') as FechaRegistro,
    contra.id_tipo_doc as TipoDocumentoIdentidad,
    contra.num_doc as NumeroDocumentoTercero,
    forpag.valor as ValoroCuentaPorPagar,
    0 as TasaCambio,
    0 as ValorIVA,
    'RADICADO:' || forpag.numero_radicado || ' - PAGO FACTURA ' || forpag.no_factura || ' PERIODO ' || to_char(forpag.fecha_ini_periodo,'dd/mm/yyyy') || ' AL PERIODO ' || to_char(forpag.fecha_fin_periodo,'dd/mm/yyyy') || upper(forpag.nombre_proveedor) as TextoCreacion,
    17 as TipoDocSoporte,
    --11 as entidad,
    forpag.no_factura as NumeroDocSoporte,
    to_char(sysdate,'yyyy-mm-dd') as FechaSolicitud,
    16 as Expedidor,
    forpag.nombre_supervisor_sede as NombreFuncionario,
    'SUPERVISOR' as CargoFuncionario,
    forpag.id_cen_op as entidad,
    '' as observacion,
    '' as urlDocumento,
    '' as urldescripcion,
    forpag.valor as valorpesos,
    forpag.*
    
    from rvsp_formato_factura_v forpag

    left join interceros_v contra on contra.id_mae_ter = forpag.id_mae_ter
    
    where
    forpag.rechazado = 0
    and forpag.radicado = 1
    
    order by
    forpag.fecha_radicado,
    forpag.radicado
    
)tab0 

left join datos_compania dat
on dat.id = 1   
    
where
(  
    trunc(tab0.FECHA_radicado)  between to_date('$fecha_ini','yyyy-mm-dd') and to_date('$fecha_fin','yyyy-mm-dd')
)
$whereIdmaeter
$whereIdCenop    
$whereIdNoFactura
--$whereTipoRecurso    
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[cgmv_inf_cuenta_pagar_sp] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
